#include <stdio.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <sys/ipc.h>
#include <sys/shm.h>  
#include <errno.h>
#include <string.h>

#define SHM_SIZE    10
#define SHM_MODE    (SHM_R | SHM_W)  /* read/write */

int main (void ) {
	int shmid;
	char *ptr, *shmptr;
	key_t mykey;

	printf ("%s\n%s\n",
		"I should run second. I create shared memory and read it.",
		"If everything is ok, I should read lots of * written by ex1");
	
	if ( (mykey =  ftok("/home/dilma/Cursos/mac438/", 1)) == -1) {
		printf ("Error in ftok: %s\n", strerror (errno));
		exit (1);
	}
	printf("mykey is %d\n", mykey);
	if ( ( shmid = shmget (mykey, SHM_SIZE, SHM_MODE) ) < 0 ) {
		printf ("Error in shmget: %s\n", strerror (errno));
		exit (1);
	}

	if ( ( shmptr = shmat(shmid, 0, 0) ) == (void *) -1) {
		printf ("Can't attach shared memory\n");
	}
	printf("shared memory attached from %p to %p\n",
	       shmptr, shmptr+SHM_SIZE);

	/* read it ! It has to be 1, since ex1.c will execute before
	 * and put 1 everywhere */
	
	ptr = shmptr;
	printf ("Here is what I got from the shared memory: ");
	while (ptr < shmptr + SHM_SIZE) {
		printf("%c",*ptr);
		ptr++;
	}
	printf ("\n");

	if (shmctl(shmid, IPC_RMID, 0 ) < 0 ) {
		printf ("can't remove: error in shmctl\n");
		/* notice that it will be removed only after all 
		**   processes release it */
  }
  
  exit (0);
  
}

