#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <signal.h>
#include <errno.h>
#include <string.h>


static void bye (const char* string) 
{
    printf("ERROR: %s\n", string);
    exit (1);
}

int main (int argc, char **argv) 
{
    pid_t supervisor_pid;
    int ongoing = 0, finished = 0;
    char cmd[256];

    if (argc != 2) {
	bye ("Missing supervidor pid");
    }
    supervisor_pid = atoi (argv[1]);
    if (supervisor_pid == 0) {
	bye ("Invalid pid");
    }
    
    while (1) {
	scanf("%s", cmd);
	if (strcmp (cmd, "startcall") == 0 ) {
	    ongoing++;
	    /* tell supervisor about this call */
	    if (kill (supervisor_pid, SIGUSR1) == -1) {
		bye (strerror (errno));
	    }
	}
	else if (strcmp (cmd, "endcall") == 0) {
	    ongoing--;
	    finished++;
	    /* tell supervisor about this call */
	    if (kill (supervisor_pid, SIGUSR2) == -1) {
		bye (strerror (errno));
	    }
	}
	else if (strcmp (cmd, "howmany") == 0) {
	    printf ("Ongoing: %d Finished: %d\n", ongoing, finished);
	}
	else {
	    printf ("Invalid command\n");
	}
    }
}

